﻿using GTAOnlineCasinoHelper.Extensions;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GTAOnlineCasinoHelper.Classes
{
    public class CeoModel
    {
        private static readonly CultureInfo EN_US = CultureInfo.CreateSpecificCulture("en-US");
        private static readonly List<CeoModel> CEO_MODELS = new List<CeoModel>();

        #region Standard Range
        #endregion
        #region Mid Range
        public static readonly CeoModel COQUETTE_CLASSIC = new CeoModel("Coquette Classic", CeoRange.MID);
        public static readonly CeoModel VERLIERER = new CeoModel("Verlierer", CeoRange.MID);
        public static readonly CeoModel ZENTORNO = new CeoModel("Zentorno", CeoRange.MID);
        public static readonly CeoModel TROPOS_RALLYE = new CeoModel("Tropos Rallye", CeoRange.MID);
        public static readonly CeoModel SULTAN_RS = new CeoModel("Sultan RS", CeoRange.MID);
        public static readonly CeoModel CHEETAH = new CeoModel("Cheetah", CeoRange.MID);
        public static readonly CeoModel SEVEN_SEVENTY = new CeoModel("Seven-70", CeoRange.MID);
        public static readonly CeoModel OMNIS = new CeoModel("Omnis", CeoRange.MID);
        public static readonly CeoModel ENTITY_XF = new CeoModel("Entity XF", CeoRange.MID);
        public static readonly CeoModel COQUETTE_BLACKFIN = new CeoModel("Coquette BlackFin", CeoRange.MID);
        #endregion
        #region Top Range
        public static readonly CeoModel Z_TYPE = new CeoModel("Z-Type", CeoRange.TOP);
        public static readonly CeoModel ETR_ONE = new CeoModel("ETR1", CeoRange.TOP);
        public static readonly CeoModel EIGHT_ELEVEN = new CeoModel("811", CeoRange.TOP);
        public static readonly CeoModel OSIRIS = new CeoModel("Osiris", CeoRange.TOP);
        public static readonly CeoModel REAPER = new CeoModel("Reaper", CeoRange.TOP);
        public static readonly CeoModel MAMBA = new CeoModel("Mamba", CeoRange.TOP);
        public static readonly CeoModel FMJ = new CeoModel("FMJ", CeoRange.TOP);
        public static readonly CeoModel STIRLING_GT = new CeoModel("Stirling GT", CeoRange.TOP);
        public static readonly CeoModel X_EIGHTY_PROTO = new CeoModel("X80 Proto", CeoRange.TOP);
        public static readonly CeoModel TYRUS = new CeoModel("Tyrus", CeoRange.TOP);
        public static readonly CeoModel T_TWENTY = new CeoModel("T20", CeoRange.TOP);
        public static readonly CeoModel ROOSEVELT_VALOR = new CeoModel("Roosevelt Valor", CeoRange.TOP);
        #endregion

        public string Name { get; }
        public CeoRange Range { get; }

        private CeoModel(string name, CeoRange range)
        {
            Name = name;
            Range = range;
            CEO_MODELS.Add(this);
        }

        public static List<CeoModel> GetCeoModels()
        {
            return CEO_MODELS;
        }

        public override string ToString()
        {
            return $"{Name}";
        }

        public override bool Equals(object obj)
        {
            return ReferenceEquals(this, obj);
        }

        public override int GetHashCode()
        {
            int hashCode = 17;
            hashCode = 31 * hashCode + Name.GetHashCode();
            hashCode = 31 * hashCode + Range.GetHashCode();
            return hashCode;
        }
    }
}
