﻿using GTAOnlineCasinoHelper.Classes;
using MahApps.Metro.Controls;
using MahApps.Metro.Controls.Dialogs;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace GTAOnlineCasinoHelper.Views
{
    
    public partial class CeoVehicleInventory : UserControl, INotifyPropertyChanged
    {

        private Dictionary<int, Dictionary<int, int[]>> topPlateInventory = new Dictionary<int, Dictionary<int, int[]>>()
        {
            [0] = new Dictionary<int, int[]>()
            {
                [0] = new int[] { 0, 0, 0 },
                [1] = new int[] { 0, 0, 0 },
                [2] = new int[] { 0, 0, 0 }
            },
            [1] = new Dictionary<int, int[]>()
            {
                [0] = new int[] { 0, 0, 0 },
                [1] = new int[] { 0, 0, 0 },
                [2] = new int[] { 0, 0, 0 }
            },
            [2] = new Dictionary<int, int[]>()
            {
                [0] = new int[] { 0, 0, 0 },
                [1] = new int[] { 0, 0, 0 },
                [2] = new int[] { 0, 0, 0 }
            },
            [3] = new Dictionary<int, int[]>()
            {
                [0] = new int[] { 0, 0, 0 },
                [1] = new int[] { 0, 0, 0 },
                [2] = new int[] { 0, 0, 0 }
            }
        };
        public Dictionary<int, Dictionary<int, int[]>> TopPlateInventory
        {
            get
            {
                return topPlateInventory;
            }
            private set
            {
                topPlateInventory = value;
                OnPropertyChanged("TopPlateInventory");
            }
        }

        private Dictionary<int, Dictionary<int, CeoPlate[]>> midPlates = new Dictionary<int, Dictionary<int, CeoPlate[]>>()
        {
            [0] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.COQUETTE_CLASSIC_TOPLESS,
                    CeoPlate.COQUETTE_CLASSIC_TOFFEE,
                    CeoPlate.COQUETTE_CLASSIC_CLASSY
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.SULTAN_RS_SNOWFLKE,
                    CeoPlate.SULTAN_RS_FIDELITY,
                    CeoPlate.SULTAN_RS_SHOWOFF
                }
            },
            [1] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.VERLIERER_PRECIOUS,
                    CeoPlate.VERLIERER_OUTFRONT,
                    CeoPlate.VERLIERER_CURVES
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.CHEETAH_BUZZED,
                    CeoPlate.CHEETAH_MIDNIGHT,
                    CeoPlate.CHEETAH_BIGCAT
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.ENTITY_XF_OVERFLOD,
                    CeoPlate.ENTITY_XF_IMLATE,
                    CeoPlate.ENTITY_XF_WIDEBOY
                }
            },
            [2] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.ZENTORNO_WINNING,
                    CeoPlate.ZENTORNO_OLDNEWS,
                    CeoPlate.ZENTORNO_HERO
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.COQUETTE_BLACKFIN_VINTAGE,
                    CeoPlate.COQUETTE_BLACKFIN_WIPEOUT,
                    CeoPlate.COQUETTE_BLACKFIN_BLKFIN
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.SULTAN_RS_SNOWFLKE,
                    CeoPlate.SULTAN_RS_FIDELITY,
                    CeoPlate.SULTAN_RS_SHOWOFF
                }
            },
            [3] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.TROPOS_RALLYE_1985,
                    CeoPlate.TROPOS_RALLYE_IMSORAD,
                    CeoPlate.TROPOS_RALLYE_EIGHTIES
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.OMNIS_WIDEBOD,
                    CeoPlate.OMNIS_OBEYME,
                    CeoPlate.OMNIS_DIRTY
                }
            }
        };
        public Dictionary<int, Dictionary<int, CeoPlate[]>> MidPlates
        {
            get
            {
                return midPlates;
            }
            set
            {
                midPlates = value;
                OnPropertyChanged("MidPlates");
            }
        }

        private Dictionary<int, Dictionary<int, CeoPlate[]>> topPlates = new Dictionary<int, Dictionary<int, CeoPlate[]>>()
        {
            [0] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.Z_TYPE_BIGMONEY,
                    CeoPlate.Z_TYPE_KINGPIN,
                    CeoPlate.Z_TYPE_CEO
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.REAPER_DEATH4U,
                    CeoPlate.REAPER_2FAST4U,
                    CeoPlate.REAPER_GRIM
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.X_EIGHTY_PROTO_MAKEBANK,
                    CeoPlate.X_EIGHTY_PROTO_FUTURE,
                    CeoPlate.X_EIGHTY_PROTO_TURBO
                }
            },
            [1] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.ETR_ONE_PRETTY,
                    CeoPlate.ETR_ONE_BIGBOY,
                    CeoPlate.ETR_ONE_MONARCH
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.MAMBA_BLKMAMBA,
                    CeoPlate.MAMBA_OLDBLUE,
                    CeoPlate.MAMBA_VIP
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.TYRUS_CITRUS,
                    CeoPlate.TYRUS_BESTLAP,
                    CeoPlate.TYRUS_TREX
                }
            },
            [2] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.EIGHT_ELEVEN_SLICK,
                    CeoPlate.EIGHT_ELEVEN_MIDLIFE,
                    CeoPlate.EIGHT_ELEVEN_REGAL
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.FMJ_CATCHME,
                    CeoPlate.FMJ_JOKER,
                    CeoPlate.FMJ_HOT4U
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.T_TWENTY_DEVIL,
                    CeoPlate.T_TWENTY_CARAMEL,
                    CeoPlate.T_TWENTY_TOPSPEED
                }
            },
            [3] = new Dictionary<int, CeoPlate[]>()
            {
                [0] = new CeoPlate[]
                {
                    CeoPlate.OSIRIS_SLEEK,
                    CeoPlate.OSIRIS_OHELLO,
                    CeoPlate.OSIRIS_PHARAOH
                },
                [1] = new CeoPlate[]
                {
                    CeoPlate.STIRLING_GT_RALLY,
                    CeoPlate.STIRLING_GT_MAJESTIC,
                    CeoPlate.STIRLING_GT_TOURER
                },
                [2] = new CeoPlate[]
                {
                    CeoPlate.ROOSEVELT_VALOR_OLDTIMER,
                    CeoPlate.ROOSEVELT_VALOR_LAWLESS,
                    CeoPlate.ROOSEVELT_VALOR_VALOR
                }
            }
        };
        public Dictionary<int, Dictionary<int, CeoPlate[]>> TopPlates
        {
            get
            {
                return topPlates;
            }
            set
            {
                topPlates = value;
                OnPropertyChanged("TopPlates");
            }
        }

        public CeoVehicleInventory()
        {
            this.InitializeComponent();
            this.DataContext = this;
            MainWindow.CeoVehicleInventory = this;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        private bool GetColRowIndex(object sender, out int col, out int row, out int index)
        {
            Button button = sender as Button;
            if (!(button?.DataContext is CeoPlate plate) || !(button?.Parent is Grid grid))
            {
                col = 0;
                row = 0;
                index = 0;
                return false;
            }
            col = Grid.GetColumn(grid);
            row = Grid.GetRow(grid);

            int tries = 3;
            index = 0;
            Dictionary<int, Dictionary<int, CeoPlate[]>> dictionary;
            if (plate.Model.Range == CeoRange.STANDARD)
            {
                // TODO add standard range
                dictionary = new Dictionary<int, Dictionary<int, CeoPlate[]>>();
            }
            else if (plate.Model.Range == CeoRange.MID)
            {
                dictionary = MidPlates;
            }
            else
            {
                dictionary = TopPlates;
            }
            while (tries > 0 && !dictionary[col][row][index].Equals(plate))
            {
                index++;
                tries--;
            }
            return true;
        }

        private async void Button_Add_Click(object sender, RoutedEventArgs e)
        {
            if (!GetColRowIndex(sender, out int col, out int row, out int index))
            {
                await MainWindow.Instance.ShowMessageAsync("Failed to get plate or grid", "Failed to get plate or grid from button", MessageDialogStyle.Affirmative);
                return;
            }

            TopPlateInventory[col][row][index]++;
            OnPropertyChanged("TopPlateInventory");
        }

        private async void Button_Remove_Click(object sender, RoutedEventArgs e)
        {
            if (!GetColRowIndex(sender, out int col, out int row, out int index))
            {
                await MainWindow.Instance.ShowMessageAsync("Failed to get plate or grid", "Failed to get plate or grid from button", MessageDialogStyle.Affirmative);
                return;
            }

            TopPlateInventory[col][row][index]--;
            OnPropertyChanged("TopPlateInventory");
        }
    }
    
}